# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xadcomputer`](#dsc_xadcomputer): The DSC xADComputer resource type. Automatically generated from version 2.13.0.0
* [`dsc_xaddomain`](#dsc_xaddomain): The DSC xADDomain resource type. Automatically generated from version 2.13.0.0
* [`dsc_xaddomaincontroller`](#dsc_xaddomaincontroller): The DSC xADDomainController resource type. Automatically generated from version 2.13.0.0
* [`dsc_xaddomaindefaultpasswordpolicy`](#dsc_xaddomaindefaultpasswordpolicy): The DSC xADDomainDefaultPasswordPolicy resource type. Automatically generated from version 2.13.0.0
* [`dsc_xaddomaintrust`](#dsc_xaddomaintrust): The DSC xADDomainTrust resource type. Automatically generated from version 2.13.0.0
* [`dsc_xadgroup`](#dsc_xadgroup): The DSC xADGroup resource type. Automatically generated from version 2.13.0.0
* [`dsc_xadorganizationalunit`](#dsc_xadorganizationalunit): The DSC xADOrganizationalUnit resource type. Automatically generated from version 2.13.0.0
* [`dsc_xadrecyclebin`](#dsc_xadrecyclebin): The DSC xADRecycleBin resource type. Automatically generated from version 2.13.0.0
* [`dsc_xaduser`](#dsc_xaduser): The DSC xADUser resource type. Automatically generated from version 2.13.0.0
* [`dsc_xwaitforaddomain`](#dsc_xwaitforaddomain): The DSC xWaitForADDomain resource type. Automatically generated from version 2.13.0.0

## Resource types

### `dsc_xadcomputer`

The DSC xADComputer resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xadcomputer` type.

##### `dsc_description`

Data type: `Optional[String]`

Specifies a description of the computer object

##### `dsc_displayname`

Data type: `Optional[String]`

Specifies the display name of the computer

##### `dsc_distinguishedname`

Data type: `Optional[String]`

Returns the X.500 path of the computer object

##### `dsc_dnshostname`

Data type: `Optional[String]`

Specifies the fully qualified domain name (FQDN) of the computer

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Specifies the Active Directory Domain Services instance to connect to perform the task

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Specifies if the computer account is enabled

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_location`

Data type: `Optional[String]`

Specifies the location of the computer, such as an office number

##### `dsc_manager`

Data type: `Optional[String]`

Specifies the user or group Distinguished Name that manages the computer object

##### `dsc_path`

Data type: `Optional[String]`

Specifies the X.500 path of the Organizational Unit (OU) or container where the computer is located

##### `dsc_requestfile`

Data type: `Optional[String]`

Specifies the full path to the Offline Domain Join Request file to create.

##### `dsc_serviceprincipalnames`

Data type: `Optional[Array[String]]`

Specifies the service principal names for the computer account

##### `dsc_sid`

Data type: `Optional[String]`

Returns the security identifier of the computer object

##### `dsc_userprincipalname`

Data type: `Optional[String]`

Specifies the UPN assigned to the computer account

#### Parameters

The following parameters are available in the `dsc_xadcomputer` type.

##### `dsc_computername`

namevar

Data type: `String`

Specifies the name of the computer

##### `dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the user account credentials to use to perform the task

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaddomain`

The DSC xADDomain resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xaddomain` type.

##### `dsc_databasepath`

Data type: `Optional[String]`

Path to a directory that contains the domain database

##### `dsc_domainnetbiosname`

Data type: `Optional[String]`

NetBIOS name for the new domain

##### `dsc_logpath`

Data type: `Optional[String]`

Path to a directory for the log file that will be written

##### `dsc_parentdomainname`

Data type: `Optional[String]`

Fully qualified name of the parent domain

##### `dsc_sysvolpath`

Data type: `Optional[String]`

Path to a directory where the Sysvol file will be written

#### Parameters

The following parameters are available in the `dsc_xaddomain` type.

##### `dsc_dnsdelegationcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential used for creating DNS delegation

##### `dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to query for domain existence

##### `dsc_domainname`

namevar

Data type: `String`

Name of the domain to which the user will be added

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_safemodeadministratorpassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Password for the administrator account when the computer is started in Safe Mode

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaddomaincontroller`

The DSC xADDomainController resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xaddomaincontroller` type.

##### `dsc_databasepath`

Data type: `Optional[String]`

 

##### `dsc_logpath`

Data type: `Optional[String]`

 

##### `dsc_sysvolpath`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xaddomaincontroller` type.

##### `dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_domainname`

namevar

Data type: `String`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_safemodeadministratorpassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaddomaindefaultpasswordpolicy`

The DSC xADDomainDefaultPasswordPolicy resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xaddomaindefaultpasswordpolicy` type.

##### `dsc_complexityenabled`

Data type: `Optional[Boolean]`

Whether password complexity is enabled for the default password policy

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Active Directory domain controller to enact the change upon

##### `dsc_lockoutduration`

Data type: `Optional[Integer[0, 4294967295]]`

Length of time that an account is locked after the number of failed login attempts (minutes)

##### `dsc_lockoutobservationwindow`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum time between two unsuccessful login attempts before the counter is reset to 0 (minutes)

##### `dsc_lockoutthreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Number of unsuccessful login attempts that are permitted before an account is locked out

##### `dsc_maxpasswordage`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum length of time that you can have the same password (minutes)

##### `dsc_minpasswordage`

Data type: `Optional[Integer[0, 4294967295]]`

Minimum length of time that you can have the same password (minutes)

##### `dsc_minpasswordlength`

Data type: `Optional[Integer[0, 4294967295]]`

Minimum number of characters that a password must contain

##### `dsc_passwordhistorycount`

Data type: `Optional[Integer[0, 4294967295]]`

Number of previous passwords to remember

##### `dsc_reversibleencryptionenabled`

Data type: `Optional[Boolean]`

Whether the directory must store passwords using reversible encryption

#### Parameters

The following parameters are available in the `dsc_xaddomaindefaultpasswordpolicy` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to access the domain

##### `dsc_domainname`

namevar

Data type: `String`

Name of the domain to which the password policy will be applied

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaddomaintrust`

The DSC xADDomainTrust resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xaddomaintrust` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this resource be present or absent

##### `dsc_trustdirection`

Data type: `Enum['Bidirectional', 'Inbound', 'Outbound']`

Direction of trust

##### `dsc_trusttype`

Data type: `Enum['External', 'Forest']`

Type of trust

#### Parameters

The following parameters are available in the `dsc_xaddomaintrust` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_sourcedomainname`

namevar

Data type: `String`

Name of the AD domain that is requesting the trust

##### `dsc_targetdomainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials to authenticate to the target domain

##### `dsc_targetdomainname`

namevar

Data type: `String`

Name of the AD domain that is being trusted

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xadgroup`

The DSC xADGroup resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xadgroup` type.

##### `dsc_category`

Data type: `Optional[Enum['Security', 'Distribution']]`

Active Directory group category

##### `dsc_description`

Data type: `Optional[String]`

Description of the Active Directory group

##### `dsc_displayname`

Data type: `Optional[String]`

Display name of the Active Directory group

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Active Directory domain controller to enact the change upon

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this resource be present or absent

##### `dsc_groupscope`

Data type: `Optional[Enum['DomainLocal', 'Global', 'Universal']]`

Active Directory group scope

##### `dsc_managedby`

Data type: `Optional[String]`

Active Directory managed by attribute specified as a DistinguishedName

##### `dsc_members`

Data type: `Optional[Array[String]]`

Active Directory group membership should match membership exactly

##### `dsc_membershipattribute`

Data type: `Optional[Enum['SamAccountName', 'DistinguishedName', 'ObjectGUID', 'SID']]`

Active Directory attribute used to perform membership operations

##### `dsc_memberstoexclude`

Data type: `Optional[Array[String]]`

Active Directory group should NOT include these members

##### `dsc_memberstoinclude`

Data type: `Optional[Array[String]]`

Active Directory group should include these members

##### `dsc_notes`

Data type: `Optional[String]`

Active Directory group notes field

##### `dsc_path`

Data type: `Optional[String]`

Location of the group within Active Directory expressed as a Distinguished Name

#### Parameters

The following parameters are available in the `dsc_xadgroup` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to enact the change upon

##### `dsc_groupname`

namevar

Data type: `String`

Name of the Active Directory group

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xadorganizationalunit`

The DSC xADOrganizationalUnit resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xadorganizationalunit` type.

##### `dsc_description`

Data type: `Optional[String]`

The description of the OU

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_protectedfromaccidentaldeletion`

Data type: `Optional[Boolean]`

Defaults to True

#### Parameters

The following parameters are available in the `dsc_xadorganizationalunit` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential to be used to perform the operation on Active Directory

##### `dsc_name`

namevar

Data type: `String`

The name of OU

##### `dsc_path`

namevar

Data type: `String`

Specifies the X500 path of the OU or container where the new object is created

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xadrecyclebin`

The DSC xADRecycleBin resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xadrecyclebin` type.

##### `dsc_forestmode`

Data type: `Optional[String]`

 

##### `dsc_recyclebinenabled`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xadrecyclebin` type.

##### `dsc_enterpriseadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_forestfqdn`

namevar

Data type: `String`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaduser`

The DSC xADUser resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xaduser` type.

##### `dsc_cannotchangepassword`

Data type: `Optional[Boolean]`

Specifies whether the account password can be changed

##### `dsc_city`

Data type: `Optional[String]`

Specifies the user's town or city (ldapDisplayName 'l')

##### `dsc_commonname`

Data type: `Optional[String]`

Specifies the common nane assigned to the user account (ldapDisplayName 'cn')

##### `dsc_company`

Data type: `Optional[String]`

Specifies the user's company (ldapDisplayName 'company')

##### `dsc_country`

Data type: `Optional[String]`

Specifies the country or region code for the user's language of choice (ldapDisplayName 'c')

##### `dsc_department`

Data type: `Optional[String]`

Specifies the user's department (ldapDisplayName 'department')

##### `dsc_description`

Data type: `Optional[String]`

Specifies a description of the object (ldapDisplayName 'description')

##### `dsc_displayname`

Data type: `Optional[String]`

Specifies the display name of the object (ldapDisplayName 'displayName')

##### `dsc_distinguishedname`

Data type: `Optional[String]`

Returns the X.500 path of the object

##### `dsc_division`

Data type: `Optional[String]`

Specifies the user's division (ldapDisplayName 'division')

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Specifies the Active Directory Domain Services instance to use to perform the task.

##### `dsc_emailaddress`

Data type: `Optional[String]`

Specifies the user's e-mail address (ldapDisplayName 'mail')

##### `dsc_employeeid`

Data type: `Optional[String]`

Specifies the user's employee ID (ldapDisplayName 'employeeID')

##### `dsc_employeenumber`

Data type: `Optional[String]`

Specifies the user's employee number (ldapDisplayName 'employeeNumber')

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Specifies if the account is enabled (default True)

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the user account is created or deleted

##### `dsc_fax`

Data type: `Optional[String]`

Specifies the user's fax phone number (ldapDisplayName 'facsimileTelephoneNumber')

##### `dsc_givenname`

Data type: `Optional[String]`

Specifies the user's given name (ldapDisplayName 'givenName')

##### `dsc_homedirectory`

Data type: `Optional[String]`

Specifies a user's home directory path (ldapDisplayName 'homeDirectory')

##### `dsc_homedrive`

Data type: `Optional[String]`

Specifies a drive that is associated with the UNC path defined by the HomeDirectory property (ldapDisplayName 'homeDrive')

##### `dsc_homepage`

Data type: `Optional[String]`

Specifies the URL of the home page of the object (ldapDisplayName 'wWWHomePage')

##### `dsc_homephone`

Data type: `Optional[String]`

Specifies the user's home telephone number (ldapDisplayName 'homePhone')

##### `dsc_initials`

Data type: `Optional[String]`

Specifies the initials that represent part of a user's name (ldapDisplayName 'initials')

##### `dsc_ipphone`

Data type: `Optional[String]`

Specifies the user's IP telephony phone number (ldapDisplayName 'ipPhone')

##### `dsc_jobtitle`

Data type: `Optional[String]`

Specifies the user's title (ldapDisplayName 'title')

##### `dsc_logonscript`

Data type: `Optional[String]`

Specifies a path to the user's log on script (ldapDisplayName 'scriptPath')

##### `dsc_manager`

Data type: `Optional[String]`

Specifies the user's manager specified as a Distinguished Name (ldapDisplayName 'manager')

##### `dsc_mobilephone`

Data type: `Optional[String]`

Specifies the user's mobile phone number (ldapDisplayName 'mobile')

##### `dsc_notes`

Data type: `Optional[String]`

Specifies the notes attached to the user's accoutn (ldapDisplayName 'info')

##### `dsc_office`

Data type: `Optional[String]`

Specifies the location of the user's office or place of business (ldapDisplayName 'physicalDeliveryOfficeName')

##### `dsc_officephone`

Data type: `Optional[String]`

Specifies the user's office telephone number (ldapDisplayName 'telephoneNumber')

##### `dsc_pager`

Data type: `Optional[String]`

Specifies the user's pager number (ldapDisplayName 'pager')

##### `dsc_passwordauthentication`

Data type: `Optional[Enum['Default', 'Negotiate']]`

Specifies the authentication context type used when testing passwords

##### `dsc_passwordneverexpires`

Data type: `Optional[Boolean]`

Specifies whether the password of an account can expire

##### `dsc_path`

Data type: `Optional[String]`

Specifies the X.500 path of the Organizational Unit (OU) or container where the new object is created

##### `dsc_pobox`

Data type: `Optional[String]`

Specifies the user's post office box number (ldapDisplayName 'postOfficeBox')

##### `dsc_postalcode`

Data type: `Optional[String]`

Specifies the user's postal code or zip code (ldapDisplayName 'postalCode')

##### `dsc_profilepath`

Data type: `Optional[String]`

Specifies a path to the user's profile (ldapDisplayName 'profilePath')

##### `dsc_state`

Data type: `Optional[String]`

Specifies the user's or Organizational Unit's state or province (ldapDisplayName 'st')

##### `dsc_streetaddress`

Data type: `Optional[String]`

Specifies the user's street address (ldapDisplayName 'streetAddress')

##### `dsc_surname`

Data type: `Optional[String]`

Specifies the user's last name or surname (ldapDisplayName 'sn')

##### `dsc_userprincipalname`

Data type: `Optional[String]`

Specifies the UPN assigned to the user account (ldapDisplayName 'userPrincipalName')

#### Parameters

The following parameters are available in the `dsc_xaduser` type.

##### `dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the user account credentials to use to perform this task

##### `dsc_domainname`

namevar

Data type: `String`

Name of the domain where the user account is located (only used if password is managed)

##### `dsc_password`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies a new password value for the account

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_username`

namevar

Data type: `String`

Specifies the Security Account Manager (SAM) account name of the user (ldapDisplayName 'sAMAccountName')

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xwaitforaddomain`

The DSC xWaitForADDomain resource type.
Automatically generated from version 2.13.0.0

#### Properties

The following properties are available in the `dsc_xwaitforaddomain` type.

##### `dsc_rebootretrycount`

Data type: `Optional[Integer[0, 4294967295]]`

 

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

 

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 18446744073709551615]]`

 

#### Parameters

The following parameters are available in the `dsc_xwaitforaddomain` type.

##### `dsc_domainname`

namevar

Data type: `String`

 

##### `dsc_domainusercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

